enum eBlocNotes_Scrollable {
  eBlocN_NotScrollable = 1, 
  eBlocN_HorizontallyScrollable = 2, 
  eBlocN_VerticallyScrollable = 3, 
  eBlocN_EvenlyScrollable = 6
};

struct BlocNotes {
  /// Converts a button to a bloc-notes and gives the focus to it
  import static function Convert(Button* button, int background_color = COLOR_TRANSPARENT, int selection_color = COLOR_TRANSPARENT, eBlocNotes_Scrollable scrollable = eBlocN_VerticallyScrollable); // $AUTOCOMPLETESTATICONLY$
  /// Gets/Sets the bloc-notes button that currently has the focus
  import static attribute Button* ActiveButton; // $AUTOCOMPLETESTATICONLY$
  import static Button* get_ActiveButton(); // $AUTOCOMPLETEIGNORE$
  import static void set_ActiveButton(Button* button); // $AUTOCOMPLETEIGNORE$
  /// Gets/Sets the bloc-notes button corresponding the the BlocNotes instance
  import attribute Button* ButtonBloc;
  import Button* get_ButtonBloc(); // $AUTOCOMPLETEIGNORE$
  import void set_ButtonBloc(Button* button); // $AUTOCOMPLETEIGNORE$
  protected Button* button;
  /// Gets the text of the bloc-notes
  import attribute String Text;
  import String get_Text(); // $AUTOCOMPLETEIGNORE$
  import void set_Text(String texte); // $AUTOCOMPLETEIGNORE$
  /// Gets the text of Nth line of the bloc-notes
  readonly import attribute String Line[];
  import String geti_Line(int n); // $AUTOCOMPLETEIGNORE$
  /// Gets the number of lines that can be displayed within the bloc-notes
  readonly import attribute int RowCount;
  import int get_RowCount(); // $AUTOCOMPLETEIGNORE$
  /// Gets the total number of lines contained in the bloc-notes
  readonly import attribute int LineCount;
  import int get_LineCount(); // $AUTOCOMPLETEIGNORE$
  /// Gets the height occupied by the texte in the bloc-notes
  readonly import attribute int Height;
  import int get_Height(); // $AUTOCOMPLETEIGNORE$
  /// Gets the width occupied by the longest line of the bloc-notes
  readonly import attribute int Width;
  import int get_Width(); // $AUTOCOMPLETEIGNORE$
  /// Gets/Sets the horizontal offset of the bloc-notes
  import attribute int XOffset;
  import int get_XOffset(); // $AUTOCOMPLETEIGNORE$
  import void set_XOffset(int xoffset); // $AUTOCOMPLETEIGNORE$
  /// Gets/Sets the vertical offset of the bloc-notes
  import attribute int YOffset;
  import int get_YOffset(); // $AUTOCOMPLETEIGNORE$
  import void set_YOffset(int yoffset); // $AUTOCOMPLETEIGNORE$
  /*// Gets the number of the line visible at the top of the bloc
  import attribute int TopLine;
  import int get_TopLine(); // $AUTOCOMPLETEIGNORE$
  import void set_TopLine(int topline); // $AUTOCOMPLETEIGNORE$*/
  /// Gets the index in bloc's text of the character on which the cursor is currently set
  import attribute int Cursor;
  import int get_Cursor(); // $AUTOCOMPLETEIGNORE$
  import void set_Cursor(int cursor); // $AUTOCOMPLETEIGNORE$
  /// Gets the selected text in the bloc-notes
  readonly import attribute String SelectedText;
  import String get_SelectedText();
  /// Gets/Puts the character on which is the selection
  import attribute int Select;
  import int get_Select();
  import void set_Select(int index);
  /// Gets the in-text position of the CARACTEREth character of the LIGNEth line of the bloc-notes
  import int GetCharIndex(int line, int character);
  /// Gets the line of the INDEXth character of the text of the bloc-notes
  import int GetLineOfChar(int index);
  /// Gets the index of the INDEXth character in its line in the bloc-notes
  import int GetPositionInLineOfChar(int index);
  /// Overwrites the file FICHIER with the content of the bloc-notes
  import function SaveInFile(String fichier);
  /// Loads the content of the file FICHIER in the bloc-notes
  import function LoadFile(String fichier);
  /// Refreshes the bloc-notes
  import function Refresh();
};

/*/// Converts a button to a bloc-notes and gives the focus to it
import function BlocN_Convert(this Button*, int couleur_fond = COLOR_TRANSPARENT, int fond_select = COLOR_TRANSPARENT, eBlocNotes_Scrollable scrollable = eBlocN_VerticallyScrollable);
/// Gets the text of the bloc-notes
import String BlocN_GetText(this Button*);
/// Gets the number of lines that can be displayed within the bloc-notes
import int BlocN_RowCount(this Button*);
/// Gets the width occupied by the longest line of the bloc-notes
import int BlocN_MaxWidth(this Button*);
/// Gets the horizontal offset of the bloc-notes
import int BlocN_GetXOffset(this Button*);
/// Sets the horizontal offset of the bloc-notes
import function BlocN_SetXOffset(this Button*, int offset);
/// Gets the total number of lines contained in the bloc-notes
import int BlocN_LinesCount(this Button*);
/// Gets the number of the line visible at the top of the bloc
import int BlocN_GetTopline(this Button*);
/// Gets the index in bloc's text of the character on which the cursor is currently set
import int BlocN_GetCursor(this Button*);
/// Places the cursor on the INDEXth character from the beginning of the text, selecting SELECTION characters
import function BlocN_SetCursor(this Button*, int caractere, int selection = 0);
/// Gets the in-text position of the CARACTEREth character of the LIGNEth line of the bloc-notes
import int BlocN_GetCharIndex(this Button*, int ligne, int caractere);
/// Gets an int couple [line,position] corresponding to the INDEXth character of the bloc's text
import int[] BlocN_GetCharLinePos(this Button*, int index);
/// Sets the index of the first line currently displayed in bloc-notes.
import function BlocN_SetTopline(this Button*, int n);
/// Sets the text displayed in the bloc-notes.
import function BlocN_SetText(this Button*, String texte);
/// Overwrites the file FICHIER with the content of the bloc-notes
import function BlocN_SaveInFile(this Button*, String fichier);
/// Loads the content of the file FICHIER in the bloc-notes
import function BlocN_LoadFile(this Button*, String fichier);
/// Returns the bloc-notes button that currently has focus
//import Button* BlocN_GetFocus();
*/