#define REGEXP_MAX_STATES 100

struct RegExp {
  
  protected String text;
  protected String pattern;
  import attribute String Pattern;
  import String get_Pattern(); // $AUTOCOMPLETEIGNORE$
  import void set_Pattern(String pattern); // $AUTOCOMPLETEIGNORE$
  
  protected String from[REGEXP_MAX_STATES]; // Les tats sources de chaque tat
  protected String to[REGEXP_MAX_STATES]; // Les tats accessibles depuis chaque tat
  protected String states[REGEXP_MAX_STATES]; // Le contenu de chaque tat
  protected String obligatory_states; // Les tats o on est oblig de passer pour satisfaire le modle
  protected String match_parenthesis; // Les correspondances
  protected String not_matched; // Les groupes  ne pas capturer
  protected String case_insensitive; // Les groupes non sensibles  la casse
  protected String min_states; // Les groupes qui doivent tre rpts un minimum de fois
  protected String max_states; // Les groupes qui ne doivent pas tre rpts plus d'un maximum de fois
  protected int min_length; // Le nombre minimum de caractres requis pour que le modle dtecte
  import int AddTo(int state, int to, int position = -1); // $AUTOCOMPLETEIGNORE$ Ajoute un tat accessible  STATE
  import int AddSourcesTo(int state, int to, int position = -1); // $AUTOCOMPLETEIGNORE$ Ajoute un tat accessible aux tats sources de STATE
  
  import int TreatContent(int state, String content); // $AUTOCOMPLETEIGNORE$ Traite le contenu
  import int NewState(String content); // $AUTOCOMPLETEIGNORE$ Cre un nouvel tat

  import int IndexOfState(String list, int state); // $AUTOCOMPLETEIGNORE$ Retourne la position de l'tat dans list
  import int IndexOfVoidState(String path); // $AUTOCOMPLETEIGNORE$ Retourne le premier caractre de PATH qui reprsente un tat "vide"
  
  /// Tests whether TEXT matches the pattern
  import bool Match(String text); // Teste si le texte rpond au modle
  /// Returns the number of times TEXT matches the pattern
  import int Count(String text); // Retourne le nombre de correspondances du modle avec le texte
  /// Replaces the first or all occurrences of the pattern in TEXT by REPLACEWITHTEXT
  import String Replace(String text, String replaceWithText, RepeatStyle repeat = eRepeat);
  
  readonly import attribute String match[]; // Les correspondances trouves (0 = tout, 1 = premier groupe, etc.)
  import String geti_match(int index); // $AUTOCOMPLETEIGNORE$
  readonly import attribute int match_start[]; // La position o commence la N-ime correspondance
  import int geti_match_start(int index); // $AUTOCOMPLETEIGNORE$
  
  /// Tests whether TEXT matches PATTERN
  import static bool MatchText(String text, String pattern); // $AUTOCOMPLETESTATICONLY$ Teste si le texte rpond au modle
  /// Replaces the first or all occurrences of PATTERN in TEXT by REPLACEWITHTEXT
  import static String ReplaceText(String text, String pattern, String replaceWithText, RepeatStyle repeat = eRepeat); // $AUTOCOMPLETESTATICONLY$
  /// Returns the number of times TEXT matches PATTERN
  import static int CountText(String text, String pattern); // $AUTOCOMPLETESTATICONLY$
  
};

/// Tests whether the text matches PATTERN
import bool RegExp_Match(this String*, String pattern);
/// Replaces the first or all occurrences of PATTERN in the text by REPLACEWITHTEXT
import String RegExp_Replace(this String*, String pattern, String replaceWithText, RepeatStyle repeat = eRepeat);
/// Returns the number of times the text matches PATTERN
import int RegExp_Count(this String*, String pattern);

// L'instance utilise pour RegExp.Match, String.RegExp_Match, RegExp.Replace et String.RegExp_Replace
import RegExp RegExp_Last;